package cn.wzpmc;

import cn.wzpmc.entities.SongObject;
import cn.wzpmc.gui.OnWorldTickStart;
import io.netty.buffer.ByteBuf;
import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.client.event.lifecycle.v1.ClientTickEvents;
import net.fabricmc.fabric.api.client.networking.v1.ClientPlayNetworking;
import net.minecraft.client.MinecraftClient;
import net.minecraft.util.Identifier;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

@Environment(EnvType.CLIENT)
public class DreamRunnerModClient implements ClientModInitializer {

    public static final Identifier packageChannelId = Objects.requireNonNull(Identifier.of("der", "music_channel"));
    public static OnWorldTickStart worldTickStart = new OnWorldTickStart();
    public static List<SongObject> musics = new ArrayList<>();

    @Override
    public void onInitializeClient() {
        ClientPlayNetworking.registerGlobalReceiver(packageChannelId, (client, handler, buf, responseSender) -> packetHandler(client, buf));
        ClientTickEvents.START_CLIENT_TICK.register(worldTickStart);
    }

    // Packet Struct:
    // SongName Length
    // SongName
    // Artist List Length
    // n Artist
    //     Artist Name Length
    //     Artist Name
    // Pic Length
    // Pic Byte Array
    // Song Length
    // Song Byte Array
    public void packetHandler(MinecraftClient client, ByteBuf buf) {
        int duringTime = buf.readInt();
        int songNameLength = buf.readInt();
        byte[] data = new byte[songNameLength];
        buf.readBytes(data);
        String songName = new String(data, StandardCharsets.UTF_8);
        StringBuilder artistsBuilder = new StringBuilder();
        int artistListLength = buf.readInt();
        for (int i = 0; i < artistListLength; i++) {
            int artistNameLength = buf.readInt();
            data = new byte[artistNameLength];
            buf.readBytes(data);
            String artistName = new String(data, StandardCharsets.UTF_8);
            artistsBuilder.append(artistName).append(',');
        }
        artistsBuilder.deleteCharAt(artistsBuilder.lastIndexOf(","));
        String artistNames = artistsBuilder.toString();
        int lrcLength = buf.readInt();
        data = new byte[lrcLength];
        buf.readBytes(data);
        String lrc = new String(data, StandardCharsets.UTF_8);
        int picByteArrayLength = buf.readInt();
        byte[] picByteArray = new byte[picByteArrayLength];
        buf.readBytes(picByteArray);
        int songByteArrayLength = buf.readInt();
        byte[] songByteArray = new byte[songByteArrayLength];
        buf.readBytes(songByteArray);
        SongObject songObject;
        try {
            songObject = new SongObject(client, songName, artistNames, duringTime, picByteArray, songByteArray, lrc);
        } catch (IOException e) {
            DreamRunnerMod.LOGGER.error("读取图片时出现错误", e);
            throw new RuntimeException(e);
        }
        if (musics.isEmpty()) {
            songObject.playSong();
        }
        musics.add(songObject);
    }
}