package cn.wzpmc.gui;

import cn.wzpmc.DreamRunnerModClient;
import cn.wzpmc.configuration.GuiConfiguration;
import cn.wzpmc.entities.SongObject;
import cn.wzpmc.utils.TimeUtils;
import io.github.cottonmc.cotton.gui.client.ScreenDrawing;
import io.github.cottonmc.cotton.gui.widget.WWidget;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.gui.DrawContext;

@Environment(EnvType.CLIENT)
public class NowSongDetailWeight extends WWidget {
    private static int targetWidth = 0;
    private static double nowWidth = 0d;
    private static double speed = 0d;
    private final MinecraftClient client;

    public NowSongDetailWeight() {
        this.client = MinecraftClient.getInstance();
    }

    public static void reset() {
        targetWidth = 0;
        nowWidth = 0d;
        speed = 0d;
    }

    private static final int textBaseX = GuiConfiguration.coverWidth + 2;
    @Override
    public void paint(DrawContext context, int x, int y, int mouseX, int mouseY) {
        if (!DreamRunnerModClient.musics.isEmpty()) {
            SongObject musicObject = DreamRunnerModClient.musics.get(0);
            if ((int) nowWidth != targetWidth) {
                nowWidth += speed;
            }
            speed = (targetWidth - nowWidth) / 60;
            ScreenDrawing.coloredRect(context, x - 2, y - 2, (int) nowWidth, GuiConfiguration.coverHeight + 4, GuiConfiguration.backgroundColor);
            context.drawTexture(musicObject.getImageId(), x, y, 0, 0, 0, GuiConfiguration.coverWidth, GuiConfiguration.coverHeight, GuiConfiguration.coverWidth, GuiConfiguration.coverHeight);
            String musicName = musicObject.getName();
            String artists = musicObject.getArtists();
            int musicNameWidth = client.textRenderer.getWidth(musicName);
            int artistsNameWidth = client.textRenderer.getWidth(artists);
            Long nowDuringTime = musicObject.getNowDuringTime();
            Long totalDuringTime = musicObject.getTotalDuringTime();
            context.drawText(client.textRenderer, musicName, textBaseX + x, y, GuiConfiguration.textColor, false);
            context.drawText(client.textRenderer, artists, textBaseX + x, client.textRenderer.fontHeight + y, GuiConfiguration.textColor, false);
            ScreenDrawing.coloredRect(context, GuiConfiguration.coverWidth + 2 + x, client.textRenderer.fontHeight * 2 + y, (int) (((double) nowDuringTime / totalDuringTime) * 100), client.textRenderer.fontHeight + 4, GuiConfiguration.progressColor);
            ScreenDrawing.coloredRect(context, GuiConfiguration.coverWidth + 2 + x, client.textRenderer.fontHeight * 2 + y, 100, client.textRenderer.fontHeight + 4, GuiConfiguration.progressBackgroundColor);
            context.drawText(client.textRenderer, TimeUtils.getTimeString(nowDuringTime) + " / " + TimeUtils.getTimeString(totalDuringTime), GuiConfiguration.coverWidth + 4 + x, client.textRenderer.fontHeight * 2 + 2 + y, GuiConfiguration.textColor, false);
            String lrc = musicObject.getLrc();
            context.drawText(client.textRenderer, lrc, textBaseX + x, client.textRenderer.fontHeight * 3 + 4 + y, GuiConfiguration.textColor, false);
            int lrcWidth = client.textRenderer.getWidth(lrc);
            targetWidth = Math.max(Math.max(Math.max(musicNameWidth, artistsNameWidth), lrcWidth), 100) + GuiConfiguration.coverWidth + 6;
        } else {
            reset();
        }
    }
}
