package cn.wzpmc.gui;

import cn.wzpmc.DreamRunnerModClient;
import cn.wzpmc.configuration.GuiConfiguration;
import cn.wzpmc.entities.SongObject;
import io.github.cottonmc.cotton.gui.client.CottonHud;
import io.github.cottonmc.cotton.gui.widget.WWidget;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.client.event.lifecycle.v1.ClientTickEvents;
import net.minecraft.client.MinecraftClient;

import java.util.ArrayList;
import java.util.List;

@Environment(EnvType.CLIENT)
public class OnWorldTickStart implements ClientTickEvents.StartTick {
    private final List<WWidget> songList = new ArrayList<>();
    private WWidget nowSongDetail;

    @Override
    public void onStartTick(MinecraftClient client) {
        if (nowSongDetail != null) {
            CottonHud.remove(nowSongDetail);
        }
        for (WWidget wWidget : songList) {
            CottonHud.remove(wWidget);
        }
        songList.clear();
        int i = 0;
        for (SongObject music : DreamRunnerModClient.musics) {
            if (i != 0) {
                SongDetailWeight songDetailWeight = new SongDetailWeight(music);
                CottonHud.add(songDetailWeight, GuiConfiguration.baseX, (i * 2) + ((i - 1) * (MinecraftClient.getInstance().textRenderer.fontHeight + 4)) + GuiConfiguration.coverHeight + GuiConfiguration.baseY + 4);
                songList.add(songDetailWeight);
            }
            i++;
        }
        nowSongDetail = new NowSongDetailWeight();
        CottonHud.add(nowSongDetail, GuiConfiguration.baseX + 2, GuiConfiguration.baseY + 2);
    }

    public void remove() {
        if (nowSongDetail != null) {
            CottonHud.remove(nowSongDetail);
        }
        nowSongDetail = null;
        for (WWidget wWidget : songList) {
            CottonHud.remove(wWidget);
        }
        songList.clear();
    }
}
