package cn.wzpmc.sounds;

import cn.wzpmc.DreamRunnerMod;
import cn.wzpmc.entities.SongObject;
import javazoom.jl.decoder.BitstreamException;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.client.network.ClientPlayerEntity;
import net.minecraft.client.sound.*;
import net.minecraft.sound.SoundCategory;
import net.minecraft.util.Identifier;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.CompletableFuture;

@Environment(EnvType.CLIENT)
public class MusicSoundInstance extends AbstractSoundInstance implements TickableSoundInstance {
    private final ClientPlayerEntity entity;
    private final InputStream inputStream;
    private final SongObject songObject;

    public MusicSoundInstance(ClientPlayerEntity entity, InputStream inputStream, SongObject songObject) {
        super(new Identifier("der", "music"), SoundCategory.RECORDS, SoundInstance.createRandom());
        this.entity = entity;
        this.inputStream = inputStream;
        this.songObject = songObject;
    }

    @Override
    public double getX() {
        this.x = this.entity.getX();
        return this.x;
    }

    @Override
    public double getY() {
        this.y = this.entity.getY();
        return this.y;
    }

    @Override
    public double getZ() {
        this.z = this.entity.getZ();
        return this.z;
    }

    @Override
    public CompletableFuture<AudioStream> getAudioStream(SoundLoader loader, Identifier id, boolean repeatInstantly) {
        try {
            MyAudioStream myAudioStream = new MyAudioStream(inputStream, songObject);
            return CompletableFuture.completedFuture(myAudioStream);
        } catch (IOException | BitstreamException e) {
            DreamRunnerMod.LOGGER.error("读取音频文件出错！", e);
        }
        return null;
    }

    @Override
    public boolean isDone() {
        return this.songObject.isDone();
    }

    @Override
    public void tick() {
    }
}
