package cn.wzpmc.sounds;

import cn.wzpmc.DreamRunnerMod;
import cn.wzpmc.DreamRunnerModClient;
import cn.wzpmc.entities.SongObject;
import javazoom.jl.decoder.*;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.client.sound.AudioStream;

import javax.sound.sampled.AudioFormat;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;

@Environment(EnvType.CLIENT)
public class MyAudioStream implements AudioStream {
    private final Bitstream bitstream;
    private final Decoder decoder;
    private final AudioFormat format;
    private final SongObject songObject;

    public MyAudioStream(InputStream inputStream, SongObject songObject) throws BitstreamException, IOException {
        this.bitstream = new Bitstream(inputStream);
        this.decoder = new Decoder();
        this.songObject = songObject;
        Header header = bitstream.readFrame();
        if (header == null) {
            throw new IOException("读取MP3文件头失败！");
        }
        this.format = new AudioFormat(header.frequency(), 16, header.mode() == Header.SINGLE_CHANNEL ? 1 : 2, true, false);
        bitstream.unreadFrame();
    }
    @Override
    public void close() {
        try {
            this.bitstream.close();
        } catch (Exception e) {
            DreamRunnerMod.LOGGER.error("关闭资源失败！", e);
        }
        DreamRunnerModClient.musics.remove(this.songObject);
        if (DreamRunnerModClient.musics.isEmpty()) {
            return;
        }
        SongObject nextSong = DreamRunnerModClient.musics.get(0);
        nextSong.playSong();
    }
    @Override
    public AudioFormat getFormat() {
        return this.format;
    }

    @Override
    public ByteBuffer getBuffer(int size) {
        ByteBuffer buffer = ByteBuffer.allocateDirect(size).order(ByteOrder.nativeOrder());
        try {
            while (buffer.hasRemaining()) {
                Header frameHeader = bitstream.readFrame();
                if (frameHeader == null) {
                    break;
                }
                SampleBuffer output = (SampleBuffer) decoder.decodeFrame(frameHeader, bitstream);
                int bufferLength = output.getBufferLength();
                short[] pcm = output.getBuffer();
                for (int i = 0; i < bufferLength; i++) {
                    if (!buffer.hasRemaining()) {
                        break;
                    }
                    buffer.putShort(pcm[i]);
                }
                bitstream.closeFrame();
            }
        } catch (Exception e) {
            DreamRunnerMod.LOGGER.error("读取音频文件失败！", e);
            return null;
        }
        buffer.flip();
        return buffer;
    }
}
