package cn.wzpmc;

import carpet.CarpetExtension;
import carpet.CarpetServer;
import com.google.common.reflect.TypeToken;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import net.fabricmc.api.ModInitializer;
import net.minecraft.scoreboard.ScoreboardObjective;
import net.minecraft.scoreboard.ScoreboardPlayerScore;
import net.minecraft.scoreboard.ServerScoreboard;
import net.minecraft.server.MinecraftServer;
import org.apache.commons.io.IOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import java.util.Collection;
import java.util.Collections;
import java.util.Map;

public class DreamRunnerMod implements ModInitializer, CarpetExtension {
    // This logger is used to write text to the console and the log file.
    // It is considered best practice to use your mod id as the logger's name.
    // That way, it's clear which mod wrote info, warnings, and errors.
    public static final Logger LOGGER = LoggerFactory.getLogger("DreamRunnerCarpetAddition");

    static {
        System.out.println();
        CarpetServer.manageExtension(new DreamRunnerMod());
    }

    @Override
    public void onInitialize() {
        // This code runs as soon as Minecraft is in a mod-load-ready state.
        // However, some things (like resources) may still be uninitialized.
        // Proceed with mild caution.
        LOGGER.info("Fuck you out of order chat!!!");
    }

    @Override
    public void onGameStarted() {
        // let's /carpet handle our few simple settings
        CarpetServer.settingsManager.parseSettingsClass(CarpetSettings.class);
    }

    public void onTick(MinecraftServer server) {
        if (CarpetSettings.clearBotScoreBoard) {
            ServerScoreboard scoreboard = server.getScoreboard();
            Collection<ScoreboardObjective> objectives = scoreboard.getObjectives();
            for (ScoreboardObjective objective : objectives) {
                Collection<ScoreboardPlayerScore> allPlayerScores = scoreboard.getAllPlayerScores(objective);
                for (ScoreboardPlayerScore allPlayerScore : allPlayerScores) {
                    String playerName = allPlayerScore.getPlayerName();
                    if (playerName.startsWith("bot_")) {
                        allPlayerScore.clearScore();
                    }
                }
            }
        }
    }

    @Override
    public Map<String, String> canHasTranslations(String lang) {
        InputStream langFile = DreamRunnerMod.class.getClassLoader().getResourceAsStream("assets/der/lang/%s.json".formatted(lang));
        if (langFile == null) {
            // we don't have that language
            return Collections.emptyMap();
        }
        String jsonData;
        try {
            jsonData = IOUtils.toString(langFile, StandardCharsets.UTF_8);
        } catch (IOException e) {
            return Collections.emptyMap();
        }
        Gson gson = new GsonBuilder().setLenient().create(); // lenient allows for comments
        return gson.fromJson(jsonData, new TypeToken<Map<String, String>>() {
        }.getType());
    }
}